﻿using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        #region Constructor
        public Form1()
        {
            InitializeComponent();

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 6; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            #endregion

            #region Grid Settings
            this.gridGroupingControl1.ThemesEnabled = true;
            this.gridGroupingControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Metro;
            this.gridGroupingControl1.ActivateCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridCellActivateAction.DblClickOnCell;
            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            #endregion

            //Event Triggering
            this.gridGroupingControl1.TableControlCellDoubleClick += GridGroupingControl1_TableControlCellDoubleClick;
           }
        #endregion

        #region CellDoubleClick Event Customization
        //Event Customization
        private void GridGroupingControl1_TableControlCellDoubleClick(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellClickEventArgs e)
        {
            //To pass the column index and row index of current record
            int columnIndex = e.Inner.ColIndex;
            int rowIndex = e.Inner.RowIndex;
            //Console.WriteLine(GetRecordValue(rowIndex, columnIndex));
            MessageBox.Show(GetRecordValue(rowIndex, columnIndex));
        }
        #endregion

        #region GetRecordValue
        /// <summary>
        /// To get the cell value of current cell
        /// </summary>
        /// <param name="columnIndex">column index of current cell</param>
        /// <returns>returns cellValue of the current cell</returns>
        //To Get the cell value of current record
        private string GetRecordValue(int rowIndex, int columnIndex)
        {
            string cellValue = string.Empty;
            //To get the style of current cell
            GridTableCellStyleInfo style = this.gridGroupingControl1.TableControl.GetTableViewStyleInfo(rowIndex, columnIndex);
            if (style.TableCellIdentity != null && (style.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell
                || style.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell))
            {
                Record record = style.TableCellIdentity.DisplayElement.GetRecord();
                //To get the cell value of current cell
                cellValue = record.GetValue(style.TableCellIdentity.Column.Name).ToString();
            }
            return cellValue;
        }
        #endregion

    }
}
